/**
 * ComponentDecorators.ts
 * Copyright: Microsoft 2019
 *
 * Exposes helper decorator functions for use with ReSub Components
 */
import { isEqual } from './lodashMini';
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
export function CustomEqualityShouldComponentUpdate(comparator) {
    return function (constructor) {
        constructor.prototype.shouldComponentUpdate = comparator;
        return constructor;
    };
}
export function DeepEqualityShouldComponentUpdate(constructor) {
    return CustomEqualityShouldComponentUpdate(deepEqualityComparator)(constructor);
}
function deepEqualityComparator(nextProps, nextState, nextContext) {
    return isEqual(this.state, nextState) || isEqual(this.props, nextProps) || isEqual(this.context, nextContext);
}
