/**
* Types.ts
* Author: David de Regt
* Copyright: Microsoft 2016
*
* Shared basic types for ReSub.
*/
import { StoreBase } from './StoreBase';
export interface SubscriptionCallbackFunction {
    (keys?: string[]): void;
}
export interface SubscriptionCallbackBuildStateFunction<S> {
    (keys?: string[]): Partial<S> | void;
}
export interface StoreSubscription<P, S> {
    store: StoreBase;
    callbackBuildState?: SubscriptionCallbackBuildStateFunction<S>;
    callback?: SubscriptionCallbackFunction;
    keyPropertyName?: keyof P;
    specificKeyValue?: string | number;
    enablePropertyName?: keyof P;
}
