"use strict";
/**
 * ComponentDecorators.ts
 * Copyright: Microsoft 2019
 *
 * Exposes helper decorator functions for use with ReSub Components
 */
Object.defineProperty(exports, "__esModule", { value: true });
var lodashMini_1 = require("./lodashMini");
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
function CustomEqualityShouldComponentUpdate(comparator) {
    return function (constructor) {
        constructor.prototype.shouldComponentUpdate = comparator;
        return constructor;
    };
}
exports.CustomEqualityShouldComponentUpdate = CustomEqualityShouldComponentUpdate;
function DeepEqualityShouldComponentUpdate(constructor) {
    return CustomEqualityShouldComponentUpdate(deepEqualityComparator)(constructor);
}
exports.DeepEqualityShouldComponentUpdate = DeepEqualityShouldComponentUpdate;
function deepEqualityComparator(nextProps, nextState, nextContext) {
    return lodashMini_1.isEqual(this.state, nextState) || lodashMini_1.isEqual(this.props, nextProps) || lodashMini_1.isEqual(this.context, nextContext);
}
